import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import * as React from "react";
import CodeMirror from './components/CodeMirror';
import PreviewMarkdown from './components/PreviewMarkdown';
import ToolBar from './components/ToolBar';
import "./index.css";

var MarkdownEditor =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(MarkdownEditor, _React$PureComponent);

  function MarkdownEditor() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MarkdownEditor);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MarkdownEditor)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "preview", void 0);

    _defineProperty(_assertThisInitialized(_this), "CodeMirror", void 0);

    _defineProperty(_assertThisInitialized(_this), "getInstance", function (editor) {
      if (editor) {
        _this.CodeMirror = editor;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (editor, data, value) {
      var _ref = _this.props,
          onChange = _ref.onChange;

      if (onChange) {
        if (_this.preview) {
          _this.preview.updateSource(editor.getValue());
        }

        onChange(editor, data, value);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClick", function (type) {
      if (type === 'preview') {
        _this.previewMarkdown();

        return;
      }

      var selection = _this.CodeMirror.editor.getSelection();

      var pos = _this.CodeMirror.editor.getCursor();

      var value = ''; // 'header', 'strike', 'underline', 'olist', 'ulist', 'todo', 'link', 'image', 'quote', 'preview'

      if (type === 'bold') {
        value = selection ? "**".concat(selection, "**") : "****";
        pos.ch = selection ? pos.ch : pos.ch + 2;
      }

      if (type === 'italic') {
        value = selection ? "*".concat(selection, "*") : "**";
        pos.ch = selection ? pos.ch : pos.ch + 1;
      }

      if (type === 'header') {
        value = selection ? "# ".concat(selection) : '# ';
        pos.ch = selection ? pos.ch : pos.ch + 2;
      }

      if (type === 'strike') {
        value = selection ? "~~".concat(selection, "~~") : '~~~~';
        pos.ch = selection ? pos.ch : pos.ch + 2;
      }

      if (type === 'underline') {
        value = selection ? "<u>".concat(selection, "</u>") : '<u></u>';
        pos.ch = selection ? pos.ch : pos.ch + 3;
      }

      if (type === 'olist') {
        value = selection ? "- ".concat(selection) : '- ';
        pos.ch = selection ? pos.ch : pos.ch + 2;
      }

      if (type === 'ulist') {
        value = selection ? "1. ".concat(selection) : '1. ';
        pos.ch = selection ? pos.ch : pos.ch + 3;
      }

      if (type === 'todo') {
        value = selection ? "- [ ] ".concat(selection) : '- [ ] ';
        pos.ch = selection ? pos.ch : pos.ch + 6;
      }

      if (type === 'link') {
        value = '[连接说明](连接地址 "连接标题")';
      }

      if (type === 'image') {
        value = selection ? "".concat(selection, " ![](\u56FE\u7247\u5730\u5740 \"\u56FE\u7247\u63CF\u8FF0\")") : '![图片描述](图片地址 "图片描述")\n';
      }

      if (type === 'quote') {
        value = selection ? "> ".concat(selection) : '> ';
        pos.ch = selection ? pos.ch : pos.ch + 2;
      }

      _this.CodeMirror.editor.replaceSelection(value);

      _this.CodeMirror.editor.focus();

      _this.CodeMirror.editor.setCursor(pos.line, pos.ch);
    });

    return _this;
  }

  _createClass(MarkdownEditor, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          className = _this$props.className,
          toolbars = _this$props.toolbars,
          onChange = _this$props.onChange,
          visble = _this$props.visble,
          codemirrorProps = _objectWithoutProperties(_this$props, ["prefixCls", "className", "toolbars", "onChange", "visble"]);

      return React.createElement("div", {
        className: classnames(prefixCls, className)
      }, React.createElement(ToolBar, {
        toolbars: toolbars,
        onClick: this.onClick
      }), React.createElement("div", {
        className: classnames("".concat(prefixCls, "-content"))
      }, React.createElement(CodeMirror, _extends({
        ref: this.getInstance
      }, codemirrorProps, {
        onChange: this.onChange
      })), React.createElement(PreviewMarkdown, {
        visble: visble,
        ref: function ref(pmd) {
          return _this2.preview = pmd;
        },
        value: this.props.value
      })));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.preview) {
        this.props.visble ? this.preview.show() : this.preview.hide();
        this.CodeMirror.editor.setSize(this.props.visble ? '50%' : '100%');
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.visble !== this.props.visble) {
        nextProps.visble ? this.preview.show() : this.preview.hide();
        this.CodeMirror.editor.setSize(nextProps.visble ? '50%' : '100%');
      }
    }
  }, {
    key: "previewMarkdown",
    value: function previewMarkdown() {
      if (this.preview) {
        this.preview.state.visble ? this.preview.hide() : this.preview.show();
        this.CodeMirror.editor.setSize(this.preview.state.visble ? '100%' : '50%');
      }
    }
  }]);

  return MarkdownEditor;
}(React.PureComponent);

_defineProperty(MarkdownEditor, "displayName", 'MarkdownEditor');

_defineProperty(MarkdownEditor, "defaultProps", {
  onChange: function onChange() {
    return null;
  },
  prefixCls: 'md-editor',
  value: '',
  visble: true
});

export { MarkdownEditor as default };
//# sourceMappingURL=index.js.map