import * as React from "react";
import { IProps } from './common/props';
import CodeMirror, { ICodeMirror } from './components/CodeMirror';
import PreviewMarkdown from './components/PreviewMarkdown';
import './index.less';
export interface IMarkdownEditor extends IProps, ICodeMirror {
    prefixCls?: string;
    value?: string;
    height?: number;
    visble?: boolean;
    toolbars?: string[];
    options?: CodeMirror.EditorConfiguration;
}
interface IMarkdownEditorState {
    preview: boolean;
}
export default class MarkdownEditor extends React.PureComponent<IMarkdownEditor, IMarkdownEditorState, {}> {
    static displayName: string;
    static defaultProps: IMarkdownEditor;
    preview: PreviewMarkdown;
    CodeMirror: CodeMirror;
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: IMarkdownEditor): void;
    getInstance: (editor: CodeMirror) => void;
    private onChange;
    private previewMarkdown;
    private onClick;
}
export {};
