(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "@babel/runtime/regenerator", "@babel/runtime/helpers/asyncToGenerator", "@babel/runtime/helpers/objectSpread", "@babel/runtime/helpers/classCallCheck", "@babel/runtime/helpers/createClass", "@babel/runtime/helpers/possibleConstructorReturn", "@babel/runtime/helpers/getPrototypeOf", "@babel/runtime/helpers/assertThisInitialized", "@babel/runtime/helpers/inherits", "@babel/runtime/helpers/defineProperty", "codemirror/mode/markdown/markdown", "react", "./codemirror.css", "./index.css"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("@babel/runtime/regenerator"), require("@babel/runtime/helpers/asyncToGenerator"), require("@babel/runtime/helpers/objectSpread"), require("@babel/runtime/helpers/classCallCheck"), require("@babel/runtime/helpers/createClass"), require("@babel/runtime/helpers/possibleConstructorReturn"), require("@babel/runtime/helpers/getPrototypeOf"), require("@babel/runtime/helpers/assertThisInitialized"), require("@babel/runtime/helpers/inherits"), require("@babel/runtime/helpers/defineProperty"), require("codemirror/mode/markdown/markdown"), require("react"), require("./codemirror.css"), require("./index.css"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.regenerator, global.asyncToGenerator, global.objectSpread, global.classCallCheck, global.createClass, global.possibleConstructorReturn, global.getPrototypeOf, global.assertThisInitialized, global.inherits, global.defineProperty, global.markdown, global.react, global.codemirror, global.index);
    global.index = mod.exports;
  }
})(this, function (_exports, _regenerator, _asyncToGenerator2, _objectSpread2, _classCallCheck2, _createClass2, _possibleConstructorReturn2, _getPrototypeOf2, _assertThisInitialized2, _inherits2, _defineProperty2, _markdown, _react, _codemirror, _index) {
  "use strict";

  var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports["default"] = void 0;
  _regenerator = _interopRequireDefault(_regenerator);
  _asyncToGenerator2 = _interopRequireDefault(_asyncToGenerator2);
  _objectSpread2 = _interopRequireDefault(_objectSpread2);
  _classCallCheck2 = _interopRequireDefault(_classCallCheck2);
  _createClass2 = _interopRequireDefault(_createClass2);
  _possibleConstructorReturn2 = _interopRequireDefault(_possibleConstructorReturn2);
  _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf2);
  _assertThisInitialized2 = _interopRequireDefault(_assertThisInitialized2);
  _inherits2 = _interopRequireDefault(_inherits2);
  _defineProperty2 = _interopRequireDefault(_defineProperty2);
  _react = _interopRequireWildcard(_react);
  var SERVER_RENDERED = typeof navigator === 'undefined' || global.PREVENT_CODEMIRROR_RENDER === true;
  var cm;

  if (!SERVER_RENDERED) {
    // tslint:disable-next-line: no-var-requires
    cm = require('codemirror');
  }

  var ReactCodeMirror =
  /*#__PURE__*/
  function (_Component) {
    (0, _inherits2["default"])(ReactCodeMirror, _Component);

    // public editor!: Doc | Editor | EditorFromTextArea | Editor;
    function ReactCodeMirror(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, ReactCodeMirror);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ReactCodeMirror).call(this, props));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "textarea", void 0);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "editor", void 0);
      return _this;
    }

    (0, _createClass2["default"])(ReactCodeMirror, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        return _react["default"].createElement("textarea", {
          ref: function ref(instance) {
            return _this2.textarea = instance;
          }
        });
      }
    }, {
      key: "componentWillMount",
      value: function componentWillMount() {
        if (SERVER_RENDERED) {
          return;
        }

        if (this.props.editorWillMount) {
          this.props.editorWillMount();
        }
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        if (SERVER_RENDERED) {
          return;
        }

        var options = this.props.options;

        if (this.props.defineMode) {
          if (this.props.defineMode.name && this.props.defineMode.fn) {
            cm.defineMode(this.props.defineMode.name, this.props.defineMode.fn);
          }
        }

        var editorOption = (0, _objectSpread2["default"])({
          tabSize: 2,
          lineNumbers: true
        }, options, {
          mode: 'markdown'
        }); // 生成codemirror实例

        this.editor = cm.fromTextArea(this.textarea, editorOption);
        this.renderCodeMirror(this.props);
      }
    }, {
      key: "componentWillReceiveProps",
      value: function () {
        var _componentWillReceiveProps = (0, _asyncToGenerator2["default"])(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee(nextPros) {
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  this.renderCodeMirror(nextPros);

                case 1:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function componentWillReceiveProps(_x) {
          return _componentWillReceiveProps.apply(this, arguments);
        }

        return componentWillReceiveProps;
      }() // 将props中所有的事件处理函数映射并保存

    }, {
      key: "getEventHandleFromProps",
      value: function getEventHandleFromProps() {
        var propNames = Object.keys(this.props);
        var eventHandle = propNames.filter(function (prop) {
          return /^on+/.test(prop);
        });
        var eventDict = {};
        eventHandle.forEach(function (ele) {
          eventDict[ele] = ele.replace(/^on[A-Z]/g, function (s) {
            return s.slice(2).toLowerCase();
          });
        });
        return eventDict;
      }
    }, {
      key: "renderCodeMirror",
      value: function renderCodeMirror(props) {
        var _this3 = this;

        var value = props.value,
            width = props.width,
            height = props.height; // 获取CodeMirror用于获取其中的一些常量
        // 事件处理映射

        var eventDict = this.getEventHandleFromProps();
        Object.keys(eventDict).forEach(function (event) {
          var handle = _this3.props[event];

          _this3.editor.on(eventDict[event], handle);
        }); // Init value

        this.editor.setValue(value || ''); // this.editor.setOption(name, editorOption.mode);

        if (width || height) {
          // Setting size
          this.editor.setSize(width, height);
        }
      }
    }]);
    return ReactCodeMirror;
  }(_react.Component);

  _exports["default"] = ReactCodeMirror;
  (0, _defineProperty2["default"])(ReactCodeMirror, "defaultProps", {
    height: '100%',
    options: {
      lineNumbers: true,
      mode: 'markdown',
      tabSize: 2
    },
    value: '',
    width: '100%'
  });
});
//# sourceMappingURL=index.js.map