(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "@babel/runtime/helpers/extends", "@babel/runtime/helpers/objectWithoutProperties", "@babel/runtime/helpers/classCallCheck", "@babel/runtime/helpers/createClass", "@babel/runtime/helpers/possibleConstructorReturn", "@babel/runtime/helpers/getPrototypeOf", "@babel/runtime/helpers/assertThisInitialized", "@babel/runtime/helpers/inherits", "@babel/runtime/helpers/defineProperty", "classnames", "highlight.js", "react", "react-markdown", "./hljs.css", "./index.css", "./markdown.css"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("@babel/runtime/helpers/extends"), require("@babel/runtime/helpers/objectWithoutProperties"), require("@babel/runtime/helpers/classCallCheck"), require("@babel/runtime/helpers/createClass"), require("@babel/runtime/helpers/possibleConstructorReturn"), require("@babel/runtime/helpers/getPrototypeOf"), require("@babel/runtime/helpers/assertThisInitialized"), require("@babel/runtime/helpers/inherits"), require("@babel/runtime/helpers/defineProperty"), require("classnames"), require("highlight.js"), require("react"), require("react-markdown"), require("./hljs.css"), require("./index.css"), require("./markdown.css"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global._extends, global.objectWithoutProperties, global.classCallCheck, global.createClass, global.possibleConstructorReturn, global.getPrototypeOf, global.assertThisInitialized, global.inherits, global.defineProperty, global.classnames, global.highlight, global.react, global.reactMarkdown, global.hljs, global.index, global.markdown);
    global.index = mod.exports;
  }
})(this, function (_exports, _extends2, _objectWithoutProperties2, _classCallCheck2, _createClass2, _possibleConstructorReturn2, _getPrototypeOf2, _assertThisInitialized2, _inherits2, _defineProperty2, _classnames2, _highlight, React, _reactMarkdown, _hljs, _index, _markdown) {
  "use strict";

  var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

  var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports["default"] = void 0;
  _extends2 = _interopRequireDefault(_extends2);
  _objectWithoutProperties2 = _interopRequireDefault(_objectWithoutProperties2);
  _classCallCheck2 = _interopRequireDefault(_classCallCheck2);
  _createClass2 = _interopRequireDefault(_createClass2);
  _possibleConstructorReturn2 = _interopRequireDefault(_possibleConstructorReturn2);
  _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf2);
  _assertThisInitialized2 = _interopRequireDefault(_assertThisInitialized2);
  _inherits2 = _interopRequireDefault(_inherits2);
  _defineProperty2 = _interopRequireDefault(_defineProperty2);
  _classnames2 = _interopRequireDefault(_classnames2);
  _highlight = _interopRequireDefault(_highlight);
  React = _interopRequireWildcard(React);
  _reactMarkdown = _interopRequireDefault(_reactMarkdown);

  _highlight["default"].configure({
    classPrefix: '',
    // don't append class prefix
    tabReplace: '  ' // 2 spaces

  });

  var PreviewMarkdown =
  /*#__PURE__*/
  function (_React$Component) {
    (0, _inherits2["default"])(PreviewMarkdown, _React$Component);

    function PreviewMarkdown(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, PreviewMarkdown);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(PreviewMarkdown).call(this, props));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "node", void 0);
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "allowNode", function (node) {
        if (node.type === 'html' && node.value) {
          if (/<!--([^]+?)-->/.test(node.value)) {
            return false;
          }
        }

        return true;
      });
      _this.state = {
        value: props.value,
        visble: props.visble
      };
      return _this;
    }

    (0, _createClass2["default"])(PreviewMarkdown, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.highlight();
      }
    }, {
      key: "show",
      value: function show() {
        this.setState({
          visble: true
        });
      }
    }, {
      key: "hide",
      value: function hide() {
        this.setState({
          visble: false
        });
      }
    }, {
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps.visble !== this.props.visble) {
          this.setState({
            visble: nextProps.visble
          });
        }
      }
    }, {
      key: "highlight",
      value: function highlight() {
        var code = this.node.getElementsByTagName('code');
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = code[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var value = _step.value;
            var tag = value.parentNode;

            if (tag && tag.tagName === 'PRE') {
              _highlight["default"].highlightBlock(value);
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }, {
      key: "updateSource",
      value: function updateSource(value) {
        var _this2 = this;

        this.setState({
          value: value
        }, function () {
          _this2.highlight();
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props = this.props,
            prefixCls = _this$props.prefixCls,
            visble = _this$props.visble,
            value = _this$props.value,
            elementProps = (0, _objectWithoutProperties2["default"])(_this$props, ["prefixCls", "visble", "value"]);
        return React.createElement("div", (0, _extends2["default"])({
          ref: function ref(node) {
            return _this3.node = node;
          },
          className: (0, _classnames2["default"])("".concat(prefixCls, "-preview"), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-visble"), this.state.visble))
        }, elementProps), React.createElement(_reactMarkdown["default"], {
          className: (0, _classnames2["default"])("".concat(prefixCls, "-markdown")),
          source: this.state.value,
          escapeHtml: false,
          allowNode: this.allowNode
        }));
      }
    }]);
    return PreviewMarkdown;
  }(React.Component);

  _exports["default"] = PreviewMarkdown;
  (0, _defineProperty2["default"])(PreviewMarkdown, "defaultProps", {
    prefixCls: 'md-editor',
    visble: true
  });
});
//# sourceMappingURL=index.js.map